Attribute VB_Name = "Module1"
Option Explicit
Public hFontItem As Long, hFontOrig As Long, hFontRestore As Long
Public gSetBk As Boolean
Public gSetTxt As Boolean
Public gSetFont As Boolean

Private Declare Function DefSubclassProc Lib "comctl32.dll" Alias "#413" (ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowSubclass Lib "comctl32.dll" Alias "#410" (ByVal hwnd As Long, ByVal pfnSubclass As Long, ByVal uIdSubclass As Long, Optional ByVal dwRefData As Long) As Long
Private Declare Function RemoveWindowSubclass Lib "comctl32.dll" Alias "#412" (ByVal hwnd As Long, ByVal pfnSubclass As Long, ByVal uIdSubclass As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Public Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long



Public Const WM_NOTIFY = &H4E
Public Const WM_DESTROY = &H2
Public Const NM_FIRST As Long = 0&
Public Const NM_CUSTOMDRAW As Long = NM_FIRST - 12&
Public Type NMHDR
  hWndFrom As Long   ' Window handle of control sending message
  IDFrom As Long        ' Identifier of control sending message
  Code  As Long          ' Specifies the notification code
End Type
Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type
Public Type NMCUSTOMDRAW
  hdr As NMHDR
  dwDrawStage As Long
  hDC As Long
  rc As RECT
  dwItemSpec As Long
  uItemState As Long
  lItemlParam As Long
End Type
Public Const CDDS_PREPAINT As Long = &H1&
Public Const CDDS_ITEM As Long = &H10000
Public Const CDDS_ITEMPREPAINT As Long = CDDS_ITEM Or CDDS_PREPAINT
Public Const CDRF_NOTIFYITEMDRAW As Long = &H20&
Public Const CDRF_NEWFONT As Long = &H2&


Public Function Subclass(hwnd As Long, lpfn As Long) As Long
Subclass = SetWindowSubclass(hwnd, lpfn, 0)
End Function
Public Function UnSubclass(hwnd As Long, lpfn As Long) As Long
UnSubclass = RemoveWindowSubclass(hwnd, lpfn, 0)
End Function

Public Function LVWndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal uIdSubclass As Long, ByVal dwRefData As Long) As Long
Select Case uMsg
   Case WM_NOTIFY
            Dim tNMH As NMHDR
            CopyMemory tNMH, ByVal lParam, Len(tNMH)
            Select Case tNMH.Code
                Case NM_CUSTOMDRAW
                    Dim nmcdr As NMCUSTOMDRAW
                    CopyMemory nmcdr, ByVal lParam, LenB(nmcdr)
                    Select Case nmcdr.dwDrawStage
                        Case CDDS_PREPAINT
                            LVWndProc = CDRF_NOTIFYITEMDRAW
                            Exit Function
                        Case CDDS_ITEMPREPAINT
                            If nmcdr.dwItemSpec = 0 Then
                                If gSetBk Then SetBkColor nmcdr.hDC, vbWhite
                                If gSetTxt Then SetTextColor nmcdr.hDC, vbRed
                                If gSetFont Then
                                    If hFontItem Then
                                        SelectObject nmcdr.hDC, hFontItem
                                    Else
                                        SelectObject nmcdr.hDC, hFontOrig
                                    End If
                                End If
                            ElseIf nmcdr.dwItemSpec = 1 Then
                                If gSetBk Then SetBkColor nmcdr.hDC, vbBlack
                                If gSetTxt Then SetTextColor nmcdr.hDC, vbGreen
                                If gSetFont Then
                                    'Note that if you're setting any per-item, you're really just
                                    'doing them all per item anyway, and shouldn't bother with
                                    'WM_SETFONT, as it will glitch if we don't always do this
                                    SelectObject nmcdr.hDC, hFontOrig
                                End If
                            ElseIf nmcdr.dwItemSpec = 2 Then
                                If gSetBk Then SetBkColor nmcdr.hDC, vbYellow
                                If gSetTxt Then SetTextColor nmcdr.hDC, vbBlue
                                If gSetFont Then
                                    SelectObject nmcdr.hDC, hFontOrig
                                End If
                            End If
                            LVWndProc = CDRF_NEWFONT
                            Exit Function
                    End Select
            End Select
   Case WM_DESTROY
     Call UnSubclass(hwnd, PtrLVWndProc)

End Select
LVWndProc = DefSubclassProc(hwnd, uMsg, wParam, lParam)

End Function
Private Function PtrLVWndProc() As Long
PtrLVWndProc = FARPROC(AddressOf LVWndProc)
End Function

Private Function FARPROC(pfn As Long) As Long
  FARPROC = pfn
End Function


